<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Formulaire.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Formulaire.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>var form_inscription = document.getElementById("inscription");              // Récupération du formulaire où toutes les informations pour l'inscription de l'utilisateur seront remplies.
var recherche_adresse = document.getElementById('Recherche_Adresse')        // Récupération du champ où l'adresse de l'utilisateur sera enregistrée.
var Bouton_Validation = document.getElementById("Validation_Formulaire");          // Récupération du bouton pour la validation du formulaire.
var autorisation = document.getElementById('Autorisation_Checkbox');        // Récupération de la case à cacher pour l'autorisation de la diffusion des informations de l'utilisateur.
var fichierSelectionne = document.getElementById('Photo_Bebe_Couffin');     // Récupération du champ où la photo de l'utilisateure sera séléctionnée.

var date = new Date();
var Jour = date.getDate()
if (Jour &lt; 10){
    Jour = '0' + Jour
}
if (date.getMonth() &lt;= 8 ){
    var Mois = date.getMonth() + 1
    Mois = "0" + Mois
}
else{
    var Mois = date.getMonth() + 1
}
var Annee = date.getFullYear()
var Date_Complet = Jour + "-" + Mois + "-" + Annee /// Récupération de la date au moment de l'inscription de l'utilisateur.

var JSON_Utilisateur = { // JSON qui contiendra toutes les informations de l'utilisateurs et les données nécéssaires pour la base de données / pour l'affichage sur la carte.
    "Date": "",
    "Mail": "",
    "Prenom":"",
    "Nom": "",
    "Adresse": "",
    "Lat": "",
    "Lng": "",
    "Numero": "",
    "Photo": "" ,
}

fichierSelectionne.addEventListener('change',Ajouter_Photo)    // A chaque changement d'image, la fonction 'Ajouter_Photo' s'execute.

/**
 * @author VIROLAN Jonathan &lt;jonathan.virolan@ensg.eu>
 * @description Permet de selectionner un photo se situant sur l'ordinateur de l'utilisateur puis de l'afficher sur la page html.
 */
function Ajouter_Photo(){ // Permet d'afficher l'image que l'utilisateur à choisi et de récuperer le nom de l'image (Normalement elle récupere l'url de l'image mais celle-ci est trop longue pour l'envoi des données lors de la requete ajax).

        var file = this.files[0]; // On récupere les informations de l'image.
        document.getElementById('Affichage_Photo').innerHTML = "" // On vide à chaque fois la div contenant l'image si l'utilisateur choisit une nouvelle image.

        var img = document.createElement("img");
        img.file = file;
        img.setAttribute('id','Image')
        img.setAttribute('width','200')
        img.setAttribute('height','200')    // On crée un élément image qui correcpond à celle choisit par l'utilisateur avec une taille de 200*200.
        Affichage_Photo.appendChild(img)    // On implémente l'image (l'enfant) dans la div 'Affichage_Photo' (le parent).

        var reader = new FileReader();

        reader.addEventListener("load", function () {
            img.src = this.result;
            JSON_Utilisateur.Photo = form_inscription.elements["Photo"].value.substr(12) // Récupére le nom de l'image.
            // JSON_Utilisateur.Photo = img.src // ===> Permet de récupérer l'url de l'image mais celle-ci est trop longue pour l'envoyer que ce soit en méthode GET ou POST.
            // console.log(img.src) // Pour voir la à quoi ressemble l'url de l'image.

        }, false);
        reader.readAsDataURL(file);

}

autorisation.addEventListener('click',Autorisation_Envoi)   // La fonction 'Autorisation_Envoi' se déclenche lorsque l'utilsateur clique sur la case.
/**
 * @author VIROLAN Jonathan &lt;jonathan.virolan@ensg.eu>
 * @description Fonctionnalité permettant de bloquer l'envoi du formulaire si la case n'est pas coché.
 */
function Autorisation_Envoi(){ // Fonction Autorisation_Envoi qui permet désactiver la le bouton si celle-ci n'est pas cocher et de l'activer si elle est cochée.
    if (autorisation.checked == true){  // 'autorisation.checked' récupere une valeur boolean qui dépend de si la case est cochée (true si la case est cachée et false si elle ne l'est pas).
        Bouton_Validation.removeAttribute('disabled'); // Si la case est cochée alors le bouton est activé et on peut valider le formulaire.
    }
    else if (autorisation.checked == false){
        Bouton_Validation.setAttribute('disabled', true); // Si la case n'est pas cochée alors le bouton est désactiver et on ne peut pas valider le formulaire.
    }
}


/**
 * Le Prénom rentré par l'utilisateur.
 * @type {string}
 */
var champ_Prenom = form_inscription.elements["Prenom"];             // Récupere le prénom inscrit par l'utilisateur.
/**
 * Le Nom rentré par l'utilisateur.
 * @type {string}
 */
var champ_Nom = form_inscription.elements["Nom"];                   // Récupere le Nom inscrit par l'utilisateur.
/**
 * Le Mail rentré par l'utilisateur.
 * @type {string}
 */
var champ_Mail = form_inscription.elements["Mail"];                 // Récupere le Mail inscrit par l'utilisateur.
/**
 * L'Adresse rentrée par l'utilisateur.
 * @type {string}
 */
var champ_Adresse = form_inscription.elements["Adresse"];           // Récupere le Adresse inscrit par l'utilisateur.
/**
 * Le Numero rentré par l'utilisateur.
 * @type {string}
 */
var champ_Numero = form_inscription.elements["Numero"];             // Récupere le Numéro inscrit par l'utilisateur.

Bouton_Validation.addEventListener('click',Valider)
/**
 * @author VIROLAN Jonathan &lt;jonathan.virolan@ensg.eu>
 * @description Cette fonction vérifie que les informations rentrées par l'utilisateur sont valide.
 * @returns {XMLHttpRequest} Renvoie les valeurs du formulaire à une page php qui permet de les enregistrer dans un BDD (Cette partie là a été commentée et la page php n'est pas dans le git).
 */
function Valider(){ // Si tous les champs sont valide alors on peut envoyer les informations de l'utilisateur à une base de données pour qu'elle y soit enregistré.

    var form_OK = true;

    if(champ_Prenom.value == ""){   // Vérifie s'il y a une valeur dans le champ Prénom car celui-ci est obligatoire.
        form_OK = false;    // La valeur pour que le formulaire s'execute devient 'false'.
        champ_Prenom.className = "erreur"; // Ajout d'un nom de classe pour modificer le CSS de toutes les champs avec comme nom de classe erreur.
        alert("Tu n'as pas rentré(e) de Prénom !")  // Indication à l'utilisateur qu'il n'a pas rentré de prénom.
    }
    else if(!isNaN(parseInt(champ_Prenom.value))){ // Vérifie si la valeur dans le champ Prénom est un nombre.
        form_OK = false;
        champ_Prenom.className = "erreur";
        alert("Tu as rentré(e) un mauvais Prénom !")
    }
    else{
        champ_Prenom.removeAttribute('class') // Enleve la classe 'erreur' car l'utilisateur a bien rempli le champ prénom.
    }

    if(champ_Nom.value != ""){ // Le champ Nom n'est pas obligatoire donc si on décide de remplir ce champ alors ...
        if(!isNaN(parseInt(champ_Nom.value))){ // ... on vérifie si la valeur dans le champ Nom est un nombre.
            form_OK = false;
            champ_Nom.className = "erreur";
            alert("Tu as rentré(e) un mauvais Nom !")
        }
        else{
            champ_Nom.removeAttribute('class')
        }
    }

    var regex = /^[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*@[a-z0-9]+([_|\.|-]­{1}[a-z0-9]+)*[\.]{1}[a-z]{2,6}$/ // Variable permettant de savoir si la valeur que l'utilisateur a rentré dans le champ mail correspond bien à un mail.
    if (champ_Mail.value == "") { // Le Mail est un information obligatoire donc on teste si le champ est vide ou pas.
        form_OK = false;
        champ_Mail.className = "erreur";
        alert("Tu n'as pas rentré(e) d'Email !")
    }
    else if (regex.exec(champ_Mail.value.toLowerCase()) == null) { // Test pour savoir si le champ mail correspond bien à un mail.
        form_OK = false;
        champ_Mail.className = "erreur";
        alert('Tu as rentré(e) un mauvais Email !')
    }
    else{
        champ_Mail.removeAttribute('class')
    }

    if(champ_Adresse.value == ""){ // Champ obligatoire donc on teste si celui-ci est vide ou non.
        form_OK = false;
        champ_Adresse.className = "erreur";
        alert("Tu n'as pas rentré(e) d'adresse !")
    }
    else if(!isNaN(parseInt(champ_Adresse.value))){
        form_OK = false;
        champ_Adresse.className = "erreur";
        alert("Tu as rentré une mauvaise adresse !")
    }
    else{
        champ_Adresse.removeAttribute('class')
    }

    if(champ_Numero.value != ""){ // Le champ Numéro n'est pas obligatoire donc si on décide de remplir ce champ alors ...
        if(champ_Numero.value.length != 10){ // ... on vérifie si c'est bien un numéro de téléphone (sa taille est équivaut à 10).
            form_OK = false;
            champ_Numero.className = "erreur";
            alert('Tu as rentré(e) un mauvais Numero de Telephone !')
        }
        else{
            champ_Numero.removeAttribute('class')
        }
    }

    if(!form_OK){   // Si au minimum l'une des valeurs vues précédemment est fausse alors l'envoie des informations de n'execute pas.
        event.preventDefault() // Aucun evenement ne s'effectue.
    }

    else{
        alert('Tes informations ont été enrengistrées')

        JSON_Utilisateur.Date = Date_Complet
        JSON_Utilisateur.Prenom = champ_Prenom.value
        JSON_Utilisateur.Nom = champ_Nom.value
        JSON_Utilisateur.Mail = champ_Mail.value
        JSON_Utilisateur.Adresse = champ_Adresse.value
        JSON_Utilisateur.Numero = champ_Numero.value // Implementation de toutes les informations de l'utilisateur dans JSON.
        /*var ajax = new XMLHttpRequest();
        ajax.open('GET', 'Formulaire.php?Date='+JSON_Utilisateur.Date+'&amp;Mail='+JSON_Utilisateur.Mail+'&amp;Prenom='+JSON_Utilisateur.Prenom+'&amp;Nom='+JSON_Utilisateur.Nom+'&amp;Adresse='+JSON_Utilisateur.Adresse+'&amp;Lat='+JSON_Utilisateur.Lat+'&amp;Lng='+JSON_Utilisateur.Lng+'&amp;Numero='+JSON_Utilisateur.Numero+'&amp;Photo='+JSON_Utilisateur.Photo,true);
        ajax.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
        ajax.addEventListener('load',  function () {
            form_inscription.reset()    // Reset du formulaire (Suppression de toutes les valeus présentes dans les différents champs).
            Bouton_Validation.setAttribute('disabled', true) // Le bouton devient à nouveau non cliquable.
            document.getElementById('Affichage_Photo').innerHTML = "" // Retire la photo du formulaire.

        })
        ajax.send()*/ // Envoie des données à la page PHP qui elle-même les enverra à une base de données.
    }
}</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Global</h3><ul><li><a href="global.html#Ajouter_Photo">Ajouter_Photo</a></li><li><a href="global.html#Autorisation_Envoi">Autorisation_Envoi</a></li><li><a href="global.html#champ_Adresse">champ_Adresse</a></li><li><a href="global.html#champ_Mail">champ_Mail</a></li><li><a href="global.html#champ_Nom">champ_Nom</a></li><li><a href="global.html#champ_Numero">champ_Numero</a></li><li><a href="global.html#champ_Prenom">champ_Prenom</a></li><li><a href="global.html#Valider">Valider</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Thu Feb 27 2020 21:27:37 GMT+0100 (GMT+01:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
